# Ŀ
#                    Mystic-MOD - Mystic BBS Modification                    
# Ĵ
#   Title                         Gryphon's Last Callers                     
#   Author                        Gryphon                                    
#   Version of Mystic Required    v1.07+                                     
# Ĵ
#                                Release Type                                
# Ĵ
#   [ ] Art  [ ] BBS Mod  [ ] BBS Util  [x] MPE Script  [ ] _______________  
# Ĵ
#                                  Comments                                  
# Ĵ
#   Features                                                                 
#   ~~~~~~~~                                                                 
#   * Full configurability (MPS is included)                                 
#   * Easy to use                                                            
#   * Uses Mystic's internal MPE engine so no shelling is needed!            
# Ĵ
#                                Installation                                
# Ĵ
#   1. Move GY-LC.MPS to your \SCRIPTS directory, and the *.ANS files in     
#      to your TEXT directory                                                
#   2. Compile GY-LC.MPS                                                     
#   3. Add a menu entry in your PRELOGIN menu                                
#   4. To UPDATE an entry, the command line is GY-LC UPDATE 15 !s200         
#      15=Number of lines in the last call list.  The default is 20          
#      !s200=The ACS string that allows a caller to be added to the list.    
#   5. To View an entry, the command line is GY-LC VIEW.  Use this option    
#      in place of the Mystic GL Menu command.                               
# Ĵ
#                                What's New?                                 
# Ĵ
#     Version 1                                                              
#   * Initial Release                                                        
# Ĵ
#                                Other Stuff                                 
# Ĵ
# Ĵ
#                               Contacting Me                                
# Ĵ
#   Want to send comments, flames, suggestions or death threats?             
#                                                                            
#   Email: dperry.geo@yahoo.com                                              
#   Web  : http://cyberia.darktech.org                                       
# 
#
# ---------------------------------------------------------------------------
# GY-LC(C) 2001 By Gryphon.  All Rights Reserved.
# ---------------------------------------------------------------------------
# Modify this however you want, but don't re-release it with your name on it.
# ---------------------------------------------------------------------------


Uses CFG
Uses User

Var
	NumLines	Integer,
	F1			String,
	F2			String,
	F3			String,
	TTxt		String,
	TTxt1		String,
	Cnt			Integer,
	IsNew		String,
	ACSstr		String,
	HEADR		String,
	FOOTER		String,
	i1			Integer,
	Count		LongInt

# most of the configuration can be done in this procedure.
# Change Numlines, F1, F2, F3, HEADR, FOOTR, or IsNew as you wish.
Procedure GetUserInfo
Begin
	GetCfg
	Count:=1
	Numlines:=20
	IsNew:=''
	GetThisUser
	If UserCalls < 2 Then
		IsNew:=' |14<new>'
	Endif
	F1:=CfgDataPath+'gylccnt.dat'
	F2:=CfgDataPath+'gylc.dat'
	F3:=CfgDataPath+'gylctmp.dat'
	HEADR:=CfgTextPath+'gylchdr.ans'
	FOOTER:=CfgTextPath+'gylcftr.ans'
Pend 

Procedure UpdateCounter
Begin
	If FExist(F1) Then
		FOpen(1,Bin,ReSet,F1)
		FReadRec(1,Count)
		FClose(1)
	Endif
	Count:=Count+1
	Fopen(1,Bin,ReWrite,F1)
	FWriteRec(1,Count)
	FClose(1)
Pend

Procedure OpenFiles
Begin
	If FExist(F2) Then
		fOpen(1,Text,Reset,F2)
	Else
		fOpen(1,Text,ReWrite,F2)
	Endif

	# Create the temp file
	FOpen(3,Text,ReWrite,F3)
Pend


Procedure BuildEntry
Begin
	TTxt:=''
	TTxt1:=Int2Str(Count)
	TTxt:=TTxt+' |01'+StrRep(' ',6-Length(TTxt1)) + TTxt1
	TTxt:=TTxt+' |02'+UserAlias +StrRep(' ',20-Length(UserAlias)) 
	TTxt:=TTxt+' |04'+UserCity  +StrRep(' ',25-Length(UserCity)) 
	TTxt1:=Int2Str(UserCalls)
	TTxt:=TTxt+' |01'+StrRep(' ',6-Length(TTxt1)) + TTxt1
	TTxt1:=DateStr(DateTime,1)
	Delete(TTxt1,3,6)
	TTxt:=TTxt+' |05'+TTxt1+' |04'+TimeStr(DateTime,1)+IsNew
Pend

Procedure UpdateLC
Begin
	fWriteLn(3,TTxt)
	While not EOF(1) and i1 <= Numlines 
		fReadLn(1,TTxt)
		fWriteLn(3,TTxt)
		i1:=i1+1
	Wend
	FClose(1)

	FErase(F2)
	IF FCopy(F3,F2) Then
		FErase(F3)
	Endif
Pend

Procedure UpdateIt
Begin
	# If the counter file exists, read it, if not set counter to the default
	UpdateCounter

	# If the display file exists, create it if it doesn't 
	OpenFiles

	# Build the entry
	BuildEntry

	# Update the last call file
	UpdateLC
Pend

Procedure ViewIt
Begin
	DispFile(HEADR)
	DispFile(F2)
	DispFile(FOOTER)

	Exit
# Don't use what's below
	Cnt:=1
	FOpen(1,text,ReSet,HEADR)
	While not EOF(1)
		fReadLn(1,TTxt)
		WriteLn(TTxT)
		Cnt:=Cnt+1
		If Cnt > 20 Then
			WriteLn('|PA')
			Cnt:=1
		Endif
	Wend
	FClose(1)

	FOpen(1,Text,Reset,F2)
	While not EOF(1)
		fReadLn(1,TTxT)
		WriteLn(TTxT)
		Cnt:=Cnt+1
		If Cnt > 20 Then
			WriteLn('|PA')
			Cnt:=1
		Endif
	Wend
	FClose(1)

	FOpen(1,Text,Reset,FOOTER)
	While not EOF(1)
		fReadLn(1,TTxT)
		WriteLn(TTxT)
		Cnt:=Cnt+1
		If Cnt > 20 Then
			WriteLn('|PA')
			Cnt:=1
		Endif
	Wend
	FClose(1)
Pend

Begin
	# Get User and other information, and set the File names
	GetUserInfo

	If ParamCount < 1 Then

		WriteLn('|CRUSAGE: GY-LC [ VIEW | UPDATE <NumLines> <MaxACS> ] |CR|PA')
	
	Else

		If Upper(ParamStr(1)) = 'UPDATE'	Then
			If ParamCount < 3 Then
		WriteLn('|CRUSAGE: GY-LC [ VIEW | UPDATE <NumLines> <MaxACS> ] |CR|PA')
			Else
				Numlines:=Str2Int(ParamStr(2))
				ACSstr:=ParamStr(3)
				If ACS(ACSstr) Then
					UpdateIt
				Endif
			Endif
		Else
			If Upper(ParamStr(1)) = 'VIEW' Then
				ViewIt	
			Endif	
		Endif
	Endif

End
